// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
/* global angular */
/* global Fingerprint */
angular.module('starter', ['ionic', 'controllers', 'services', 'filters', 'directives'])
    .config(function ($logProvider, $stateProvider, $urlRouterProvider) {
        'use strict';
        $logProvider.debugEnabled(true);

        console.log("configuration...." + " " + isScreenReaderRunning);

        // 508
        $stateProvider
            .state("home", {
                cache: false,
                url: "/home",
                templateUrl: "templates/mainView-508.html",
                controller: "MainCtrl"
            })
            .state("all-cards", {
                cache: false,
                url: "/all-cards",
                templateUrl: "templates/allCardsView.html",
                // templateUrl: "templates/allCardsView-508.html",
                controller: "AllCardsCtrl"
            })
            .state("saved-cards", {
                cache: false,
                url: "/saved-cards",
                templateUrl: "templates/savedCardsView.html",
                controller: "SavedCardsCtrl"
            })
            .state("card-front", {
                cache: false,
                url: "/card-detail-front/:id",
                templateUrl: "templates/cardDetailFrontView-508.html",
                controller: "CardDetailCtrl"
            })
            .state("card-back", {
                cache: false,
                url: "/card-detail-back/:id",
                templateUrl: "templates/cardDetailBackView-508.html",
                controller: "CardDetailCtrl"
            })
            .state("search", {
                cache: false,
                url: "/search",
                templateUrl: "templates/searchView.html",
                controller: "SearchCtrl"
            })
            .state("about", {
                cache: false,
                url: "/about",
                templateUrl: "templates/aboutView.html",
                controller: "AboutCtrl"
            })
            .state("about.eula", {
                cache: false,
                url: "/eula",
                views: {
                    'about-tab@tab': {
                        templateUrl: "templates/eulaView.html",
                        controller: "eulaCtrl"
                    }
                }
            })
            .state("help", {
                cache: false,
                url: "/help",
                templateUrl: "templates/helpView.html",
                controller: "HelpCtrl"
            })
            .state("help.content", {
                cache: false,
                url: "/help/:id",
                views: {
                    "help-tab@tab": {
                        templateUrl: function ($stateParams) {
                            return "templates/help/content-" + $stateParams.id + ".html";
                        },
                        controller: "HelpCtrl"
                    }
                }
                // templateUrl: function ($stateParams) {
                //     return "templates/help/content-" + $stateParams.id + ".html";
                // },
                // controller: "HelpCtrl"
            });
        // 508

        $stateProvider
            .state("tab", {
                cache: false,
                url: "/tab",
                abstract: true,
                templateUrl: "templates/tabs.html",
                // controller: "MainCtrl"
            })
            .state("tab.home", {
                cache: false,
                url: "/home",
                views: {
                    'home-tab': {
                        // templateUrl: "templates/mainView.html",
                        templateUrl: "templates/mainView.html",
                        controller: "MainCtrl"
                    }
                }
                // templateUrl: "templates/mainView.html",
                // controller: "MainCtrl"
            })
            .state("tab.home.detail", {
                cache: false,
                url: "/card-detail/:id",
                views: {
                    'home-tab@tab': {
                        templateUrl: "templates/cardDetailView.html",
                        controller: "CardDetailCtrl"
                    }
                }
            })
            .state("tab.about", {
                cache: false,
                url: "/about",
                views: {
                    "about-tab": {
                        templateUrl: "templates/aboutView.html",
                        controller: "AboutCtrl"
                    }
                }
                // templateUrl: "templates/aboutView.html",
                // controller: "AboutCtrl"
            })
            .state("tab.about.eula", {
                cache: false,
                url: "/eula",
                views: {
                    'about-tab@tab': {
                        templateUrl: "templates/eulaView.html",
                        controller: "eulaCtrl"
                    }
                }
            })
            .state("tab.all-cards", {
                cache: false,
                url: "/all-cards",
                views: {
                    'all-tab': {
                        templateUrl: "templates/allCardsView.html",
                        controller: "AllCardsCtrl"
                    }
                }
                // templateUrl: "templates/allCardsView.html",
                // controller: "AllCardsCtrl"
            })
            .state("tab.all-cards.detail", {
                cache: false,
                url: "/card-detail/:id",
                views: {
                    'all-tab@tab': {
                        templateUrl: "templates/cardDetailView.html",
                        controller: "CardDetailCtrl"
                    }
                }
            })
            .state("tab.search", {
                cache: false,
                url: "/search",
                views: {
                    'search-tab': {
                        templateUrl: "templates/searchView.html",
                        controller: "SearchCtrl"
                    }
                }
                // templateUrl: "templates/searchView.html",
                // controller: "SearchCtrl"
            })
            .state("tab.search.detail", {
                cache: false,
                url: "/card-detail/:id",
                views: {
                    'search-tab@tab': {
                        templateUrl: "templates/cardDetailView.html",
                        controller: "CardDetailCtrl"
                    }
                }
            })
            .state("eula", {
                cache: false,
                url: "/eula",
                templateUrl: "templates/eulaView.html",
                controller: "eulaCtrl"
            })
            .state("tab.help", {
                cache: false,
                url: "/help",
                views: {
                    "help-tab": {
                        templateUrl: "templates/helpView.html",
                        controller: "HelpCtrl"
                    }
                }
                // templateUrl: "templates/helpView.html",
                // controller: "HelpCtrl"
            })
            .state("tab.help.content", {
                cache: false,
                url: "/help/:id",
                views: {
                    "help-tab@tab": {
                        templateUrl: function ($stateParams) {
                            return "templates/help/content-" + $stateParams.id + ".html";
                        },
                        controller: "HelpCtrl"
                    }
                }
                // templateUrl: function ($stateParams) {
                //     return "templates/help/content-" + $stateParams.id + ".html";
                // },
                // controller: "HelpCtrl"
            });

        if (isScreenReaderRunning) {
            $urlRouterProvider.otherwise("/home");
        } else {
            $urlRouterProvider.otherwise("/tab/home");
        }
    })
    .run(function ($ionicPlatform, $rootScope, $state) {
        'use strict';

        console.log("run...");

        $rootScope.device_hash = device_hash;
        $rootScope.myHost = host;
        $rootScope.refreshRate = _refreshRate;

        // Save state so we have access to it when handler is called.
        var _state = $state;

        function onScreenReaderStatusChange(info) {
            if (info && typeof info.isScreenReaderRunning !== "undefined") {
                console.log(_state);

                if (info.isScreenReaderRunning) {
                    console.log("Screen reader: ON");
                    // Do something to improve the behavior of the application while a screen reader is active.
                    isScreenReaderRunning = true;

                    // $urlRouterProvider.otherwise("/home");
                    _state.go(_state.current.name.replace("tab.", ""));
                } else {
                    console.log("Screen reader: OFF");
                    isScreenReaderRunning = false;

                    // $urlRouterProvider.otherwise("/tab/home");
                    _state.go("tab." + _state.current.name);
                }
            }
        }

        // Register the callback method to handle screen reader status change.
        if (window.ionic.Platform.isIOS() === true) {
            window.addEventListener(window.MobileAccessibilityNotifications.SCREEN_READER_STATUS_CHANGED, onScreenReaderStatusChange);
        }

        // Listen for when the device is online and offline so we can notify the user.
        $rootScope.$watch("isOnline", function (newValue, oldValue) {
            console.log("status change from " + oldValue + " to " + newValue);
        });

        var _rootScope = $rootScope;
        document.addEventListener("offline", function () {
            var msg = "Device is Offline!";
            console.log(msg);
            navigator.notification.alert(msg, function () {});

            _rootScope.isOnline = false;
            _rootScope.$digest();
        }, false);

        document.addEventListener("online", function () {
            var msg = "Device is Online!";
            console.log(msg);
            navigator.notification.alert(msg, function () {});

            _rootScope.isOnline = true;
            _rootScope.$digest();
        }, false);


        $ionicPlatform.ready(function () {
            console.log("ionic platform ready...");

            // Hide the accessory bar by default (remove this to show the accessory bar above the keyboard
            // for form inputs)
            // if (window.cordova && window.cordova.plugins.Keyboard) {
            //     cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            // }
            if (window.StatusBar) {
                window.StatusBar.styleDefault();
            }
        });
    });

// NOTE: Order is important!!!!
// The order is:
// 
// 1. deviceready event
// 2. run callback
// 3. ionicPlatform ready callback
// 
// The module must be define first since we're manually bootstrapping Angular.
var device_hash;
var host = "http://192.168.1.133:7010";
var isScreenReaderRunning;
var _refreshRate = 24;

// Are we running on the device?
if (document.location.protocol === "file:") {
    // Yes. Wait for the deviceready event before starting Angular.
    document.addEventListener("deviceready", function () {
        "use strict";

        console.log("deviceready fired...");

        (function () {
            var deferred = $.Deferred();

            console.log("checking application preferences...");
            window.plugins.appPreferences.fetch(function (h) {
                if (h) {
                    host = "https://" + h;
                }
                console.log("host2: " + host);
                deferred.resolve();
            }, function (error) {
                console.log('Error occurred reading application preferences! Using defaults.' + error);
                deferred.resolve();
            }, 'name_preference');

            // Get refresh rate.
            window.plugins.appPreferences.fetch(function (refreshRate) {
                if (refreshRate) {
                    console.log("refresh rate: " + refreshRate);
                    _refreshRate = refreshRate;
                    deferred.resolve();
                }
            }, function (error) {
                console.log('Warning! Using default refresh rate: Every 24h.' + error);
                deferred.resolve();
            }, "interval");

            return deferred;
        })().then(function () {
            window.MobileAccessibility.isVoiceOverRunning(function (is508) {
                if (is508) {
                    console.log("Screen Reader: ON");
                    isScreenReaderRunning = true;
                } else {
                    console.log("Screen reader: OFF");
                    isScreenReaderRunning = false;
                }

                angular.element(document).ready(function () {
                    console.log("document ready...");

                    angular.bootstrap(document.body, ["starter"]);
                });
            });

            // console.log(location.origin + location.pathname);

            // window.MobileAccessibility.isVoiceOverRunning(function (is508) {
            //     if (is508) {
            //         console.log("Screen Reader: ON");
            //         isScreenReaderRunning = true;
            //     } else {
            //         console.log("Screen reader: OFF");
            //         isScreenReaderRunning = false;
            //     }
            // });

            // TODO: Find alternate solution.
            // This may be a potiential problem since I don't know which event (deviceready or documentready)
            // is going to fire 1st.
            // angular.element(document).ready(function () {
            //     console.log("document ready...");

            //     angular.bootstrap(document.body, ["starter"]);
            // });

            // Set refresh interval.

        });

        window.wizUniqueIdentifier.get(function (id) {
            console.log(id);
            device_hash = id;
        });
    });
} else {
    device_hash = new Fingerprint().get();

    // No. Just start Angular.
    angular.element(document).ready(function () {
        "use strict";
        angular.bootstrap(document.body, ["starter"]);
    });
}

// Define a persistent callback method to handle the event
// function onScreenReaderStatusChanged(info) {
//     "use strict";

//     if (info && typeof info.isScreenReaderRunning !== "undefined") {
//         if (info.isScreenReaderRunning) {
//             console.log("Screen reader: ON");

//             // Do something to improve the behavior of the application while a screen reader is active.
//             isScreenReaderRunning = true;
//         } else {
//             console.log("Screen reader: OFF");
//             isScreenReaderRunning = false;
//         }
//     }
// }