"use strict";
/* global angular */
angular.module('directives', [])
    .directive('cardContent', function ($log, $compile, $stateParams, $webService) {
        $log.debug('Directive was run');

        // $scope.card.content = content;
        var linker = function (scope, element, attrs) {
            $webService.getPocketCardContent($stateParams.id).then(function (content) {
                var c = atob(content.buffer);
                $log.debug(c);

                // Bind the content to our element.
                element.html(c);

                // TODO: Verify the content of a pocket cards. Is the content static with no
                // fillins??? If the content contains fillins, we need to compile the content.
                // $compile(element.contents())(scope);
            });
        };

        // Setup the compiler. The compiler will default to looking for elements that contain a class
        // or attribute with the same name as this directive i.e. 'card-content'. NOTE: The name in the
        // HTML will be converted to camelCase.
        return {
            // Using default...
            // restrict: "E",
            link: linker,
            scope: {
                // Needed for fillins.
                // content: '='
            }
        };
    })
    .directive('showData', function ($log, $compile) {
        return {
            link: function (scope, element, attrs) {
                $log.debug("showData directive run...");

                var el;

                attrs.$observe('template', function (tpl) {
                    // tpl must be defined with an element or we'll get the following error:
                    // Error: [jqLite:nosel] Looking up elements view selectors is not supported by jqLite!
                    // jqLite is a subset of jQuery so this error goes away when using jQuery.
                    if (angular.isDefined(tpl)) {
                        if (tpl.length === 0) {
                            tpl = "</html>";
                        }

                        // Compile the template.
                        el = $compile(tpl)(scope);

                        // Clear the element and add the template content.
                        element.html("");
                        element.append(el);

                        var children = element.find('a');
                        _.each(children, function (child) {
                            var attribute = child.attributes.href;
                            if (attribute && attribute.value.indexOf("http:") === 0) {
                                // Add event handler to open the URL in an InAppBrowser.
                                child.onclick = function (event) {
                                    event.preventDefault();
                                    var ref = window.open(event.currentTarget.href, "_blank", "location=no");

                                    ref.addEventListener("loaderror", function (event) {
                                        alert(event.message);
                                    });
                                };
                            }
                        });
                    }
                });
            }
        };
    });