# Starting a DEV instance of the Admin web server #

## Setup as a local server process: ##

 1. Run `sudo npm install`
 2. Run `DEBUG=pcAdmin bin/www -c config_dummy.js` to run the server with a dummy (internal) DAO
 3. Run `npm start` (Mac) or `npm run-script startwin` (Windows) to run the server with a specified Mongo server
	 - Edit the `config_mongo.js` file to specify the server and database name of the Mongo database for the web server app
 4. Point your browser to http://localhost:7010

**NOTE**

Make sure MogoDB is running and you are using a userid from the "adminUsers" collection when loging in. See ../data/README.md for information on how to add users.

## How to run the tests ##

There are 2 kinds of tests for the admin web; Mocha tests that test the server side components, and Karma tests that test the web components.

### Mocha Tests ###

Run `mocha test/*test.js` to run all of these tests. You'll note that some of the tests are integration tests, and will not run unless you modify the test files (see the console output from running this command for instructions on how to run those tests).

### Karma Tests ###

In a command window, run `karma start` to start the Karma runtime in a browser. Then, in a different console window, run `karma run` to actually run the tests.


## Login (Development) ##

You will need some type of tool for modifying http requests to login when testing locally. The 'Header-Editor' extension can be used for this purpose. This tool will allow you to add the neccessary header information to the http request to login. Start by:

 1. Invoking the tool. There should be a pencil icon on the tool bar if using Chrome.
 2. Type in the header field, x-id and the value, <userid> were userid is an id from the adminUsers collection.
 3. Click 'Add'

The x-id http header field will now be added to all of your http requests.

## Login ##
 1. Login with 'user1' as the ID and anything as the password to login as a "USER" admin
 2. Login with 'user2' as the ID and anything as the password to login as a "CARD" admin

## Setup as a dedicated server process: ##

 1. Run `sudo npm install`
 2. Run `sudo npm forever -g` if the NodeJS plugin `forever` is not installed
 3. Run the command `forever bin/www -c config_dummy.js` to run the server with a dummy (internal) DAO -or-
 4. Run the command `forever bin/www -c config_mongo.js` to run the server with a specified Mongo server 
 	 - If the system says the command `forever` is not found, you may have to run the command when logged in as root
 	 - Edit the `config_mongo.js` file to specify the server and database name of the Mongo database for the web server app
 5. Point your browser to http://<host-ip-or-name>:7010
 6. Login with 'user1' as the ID and anything as the password to login as a "USER" admin
 7. Login with 'user2' as the ID and anything as the password to login as a "CARD" admin
