//errorMessages_en.js

var NO_AUTH = 'Not Authorized';
var NO_UPDATE_CARD = '; cannot update card';
var NO_UPDATE_USER = '; cannot update user';
var NO_ADD_USER = '; new user not added';

module.exports = {
	'11': 'Error getting all cards',
	'12': NO_AUTH,

	'21': NO_AUTH,
	'22': 'Card not found',
	'23': 'Card ID not specified',

	'31': NO_AUTH,
	'32': 'No Comment given for published card',
	'33': 'Error saving card',
	'34': 'Interal error saving card',
	'35': 'Error writing card audit log',
	'36': 'No card to save',

	'41': NO_AUTH,
	'42': 'User not found',
	'43': 'No user ID',

	'51': NO_AUTH,
	'52': 'No user given' + NO_ADD_USER,
	'53': 'No user system ID' + NO_ADD_USER,
	'54': 'Error saving user audit log' + NO_ADD_USER,
	'55': 'Error saving user' + NO_ADD_USER,
	'56': 'Internal error saving user' + NO_ADD_USER,
	'57': 'Error saving user post audit log' + NO_ADD_USER,
	'58': 'Last name was invalid' + NO_ADD_USER,
	'59': 'First name was invalid' + NO_ADD_USER,

	'61': 'Error getting cards',
	'62': NO_AUTH,

	'71': 'Error checking user system ID',
	'72': 'User system ID already in use',

	'81': NO_AUTH,
	'82': 'No user selected',
	'83': 'Error retrieving user',
	'84': 'User not found',

	'91': NO_AUTH,
	'92': 'No card selected',
	'93': 'Error retrieving card',
	'94': 'Card not found',

	'101': 'Error selecting user' + NO_UPDATE_USER,
	'102': 'Selected user not found' + NO_UPDATE_USER,
	'103': 'Error writing user audit' + NO_UPDATE_USER,
	'104': 'Error writing user update' + NO_UPDATE_USER,
	'105': 'No user selected or no new user data' + NO_UPDATE_USER,
	'106': NO_AUTH,
	'107': 'First name was invalid' + NO_UPDATE_USER,
	'108': 'Last name was invalid' + NO_UPDATE_USER,
	'109': 'Invalid or missing system user ID' + NO_UPDATE_USER,

	'111': 'Error selecting card' + NO_UPDATE_CARD,
	'112': 'Prior card problem' + NO_UPDATE_CARD,
	'113': 'Cannot modify a card that is not yours' + NO_UPDATE_CARD,
	'114': 'Problem with new owner ID' + NO_UPDATE_CARD,
	'115': 'Invalid new owner ID' + NO_UPDATE_CARD,
	'116': 'Comment cannot be empty for a published card' + NO_UPDATE_CARD,
	'117': 'Comment cannot be empty when unpublishing a card' + NO_UPDATE_CARD,
	'118': 'Error writing card audit' + NO_UPDATE_CARD,
	'119': 'Error writing card update' + NO_UPDATE_CARD,
	'120': NO_AUTH,

	'121': NO_AUTH,
	'122': 'Error authorizing',
	'123': 'Error authorizing',
	'124': 'Data error authorizing',
	'125': NO_AUTH,
	'126': 'Error writing authorization audit',

	'131': 'Error checking user system ID' + NO_UPDATE_USER,
	'132': 'User system ID already in use by more than 1 person' + NO_UPDATE_USER,
	'133': 'User system ID already in use' + NO_UPDATE_USER,

	'181': 'Card not found',
	'182': 'Error selecting card data',
	'183': NO_AUTH,

	'191': NO_AUTH,

	getMessage: function (id) {
		if (this[id]) {
			return this[id];
		}
		return "Error";
	}

}
