//addcard.js
var adminapp = angular.module('adminapp');

adminapp.controller('addCardController', ['$scope', '$window', 'unloadMessage', 'utils', function ($scope, win, unloadMessageFunc, utils) {
	$scope.status = 'inactive';
	win.onbeforeunload = unloadMessageFunc;
	$scope.lastFileTryError = false;
	$scope.file = null;

	$scope.setFile = function (file) {
		$scope.file = null;
		$scope.lastFileTryError = false;
		if (file) {
			if (utils.isFileValid(file)) {
				$scope.file = file;
			}
			else {
				$scope.lastFileTryError = true;
			}
		}
		if ('inactive'!=$scope.status && !$scope.file) {
			$scope.status = 'inactive';
		}
	};

	$scope.isVersionValid = function () {
		if ('active'==$scope.status) {
			return ''!=$scope.version;
		}
		return true;
	};

	$scope.isCommentValid = function () {
		if ('active'==$scope.status) {
			return ''!=$scope.versionComment;
		}
		return true;
	};

	$scope.submitClick = function () {
		win.onbeforeunload = null;
	};

	$scope.submitForm = function () {
		$scope.addCardForm.submit();
	}
}]);
