//managecards.js
var adminapp = angular.module('adminapp');

adminapp.controller('cardmetametrics', ['$scope', 'utils', function ($scope, utils) {
	var now = new Date();
	$scope.fromdt = {};
	$scope.todt = {};
	$scope.fromdt.month = $scope.todt.month = now.getMonth()+1;
	$scope.fromdt.day = 1;
	$scope.todt.day = now.getDate();
	$scope.fromdt.year = $scope.todt.year = now.getFullYear();

	$scope.msgTo = getInitMsgObject();
	$scope.msgFrom = getInitMsgObject();
	$scope.rangeOkay = true;
	$scope.stringFrom = getDateStringFloor($scope.fromdt, $scope.msgFrom);
	$scope.stringTo = getDateStringCeiling($scope.todt, $scope.msgTo);

	$scope.update = function () {
		this.evalDate(this.fromdt, this.msgFrom);
		this.evalDate(this.todt, this.msgTo);
		this.rangeOkay = this.evalRange();
		this.stringFrom = getDateStringFloor(this.fromdt, this.msgFrom);
		this.stringTo = getDateStringCeiling(this.todt, this.msgTo);
	};

	$scope.evalDate = function (dateOb, msgOb) {
		if (dateOb && msgOb) {
			this.evalNumbers(dateOb, msgOb);
			if (!msgOb.badDate) {
				this.resolveDate(dateOb, msgOb);
			}
		}
	};

	$scope.evalNumbers = function (dateOb, msgOb) {
		msgOb.badDay = isNaN(dateOb.day);
		msgOb.badMonth = isNaN(dateOb.month);
		msgOb.badYear = isNaN(dateOb.year);
		msgOb.badDate = msgOb.badDay || msgOb.badMonth || msgOb.badYear;
	};

	$scope.resolveDate = function (dateOb, msgOb) {
		var month = parseInt(dateOb.month);
		if ('NaN'===month.toString()) {
			msgOb.badMonth = true;
		}
		else {
			msgOb.badMonth = (month<1 || month>12);
		}
		var year = parseInt(dateOb.year);
		if ('NaN'===year.toString()) {
			msgOb.badYear = true;
		}
		else {
			msgOb.badYear = (year<2015);
		}
		if (!msgOb.badMonth && !msgOb.badYear) {
			var day = parseInt(dateOb.day);
			if ('NaN'===day.toString()) {
				msgOb.badDay = true;
			}
			else {
				var upperDate = 31;
				if (2==dateOb.month) {
					if (utils.isLeapYear(dateOb.year)) {
						upperDate = 29;
					}
					else {
						upperDate = 28;
					}
				}
				else {
					switch (dateOb.month) {
						case 4:
						case 6:
						case 9:
						case 11: {
							upperDate = 30;
						}
					}
				}
				msgOb.badDay = (day<1 || day>upperDate);
			}
		}
		msgOb.badDate = msgOb.badDay || msgOb.badMonth || msgOb.badYear;
	};

	$scope.evalRange = function () {
		return false===this.msgFrom.badDate && false===this.msgTo.badDate && rangeConsecutive(this.fromdt, this.todt);
	};

}]);

function getInitMsgObject () {
	return {badDay: false, badMonth: false, badYear: false, badDate: false};
}

function rangeConsecutive (fromdt, todt)  {
	try {
		return getDate(fromdt) <= getDate(todt);
	}
	catch (err) {}
	return false;
}

function getDate(dt) {
	var month = parseInt(dt.month)-1;
	var day = parseInt(dt.day);
	var year = parseInt(dt.year);
	return new Date(year, month, day);
}

function getDateStringFloor(dt, msg) {
	return getDateString(dt, msg, true);
}

function getDateStringCeiling(dt, msg) {
	return getDateString(dt, msg, false);
}

function getDateString(dt, msg, isFloor) {
	try {
		if (false===msg.badDate) {
			if (isFloor) {
				return new Date(dt.year, parseInt(dt.month)-1, dt.day, 0, 0, 0).getTime().toString();
			}
			else {
				return new Date(dt.year, parseInt(dt.month)-1, dt.day, 23, 59, 59).getTime().toString();
			}
		}
	}
	catch (err) {}
	return '0';
}
