//filters.js
var filters = angular.module('filters', []);
filters.filter('statustext', function () {
	return function (text) {
		if (text && 'active'==text) {
			return 'Published';
		}
		else {
			return 'Unpublished';
		};
	}
});

filters.filter('fileMessage', function () {
	return function (file) {
		if (file && file.originalname) {
			return 'Replace';
		}
		else {
			return 'Add';
		}
	};
});

filters.filter('filename', function () {
	return function (file) {
		if (file && file.originalname) {
			return file.originalname;
		}
		else {
			return 'None';
		}
	};
});

filters.filter('personName', function () {
	return function (person) {
		var name = "";
		if (person) {
			if (person.firstname) {
				name += person.firstname;
			}
			if (person.lastname) {
				if (name.length) {
					name += ' ';
				}
				name += person.lastname;
			}
		}
		return name;
	};
});

filters.filter('ownedBy', function () {
	return function (list, ownerId, justMine) {
		if (!justMine) {
			return list;
		}
		var ary = [];
		if (list && list.length) {
			for (var i = list.length - 1; i >= 0; i--) {
				if (ownerId==list[i].ownerId) {
					ary.push(list[i]);
				}
			}
		}
		return ary;
	};
});

filters.filter('timeToString', function () {
	return function (aDate) {
		if (!aDate) {
			return '0';
		}
		if (aDate.getTime) {
			return aDate.getTime().toString();
		}
		return aDate.toString();
	};
});

filters.filter('datetimeString', function () {
	return function (aDate) {
		return clientserverCommon.getDatetimeString(aDate);
	}
});

filters.filter('datefulltimeString', function () {
	return function(aDate) {
		return clientserverCommon.getDatetimeString(aDate, true);
	}
});
