# Unit Tests and Integration Tests #

The `mocha` test framework is used for tests. Simply type `mocha` in a command window from the parent folder of test to run all tests.

## A Note on `log4js` ##

 - The logging library `log4js` is used throughout the code. In the unit tests and integration tests, the logging level is set to the highest level to prevent messages from showing up in the tests.
 - To turn on the logging messages when testing, comment out the lines that have the `setLevel` methods called on the appropriate logger.

## To setup the database for the tests in Mongo\_dao\_itest\_test.js: ##

### I. Populate the database with sample data: ###

#### MongoDB ####

 1. Run the `mongo` manager for your Mongo instance and run the following commands;
```MONGO
use pc
db.adminUsers.insert({"id": 1, "lastname": "Joe", "firstname": "G.I.", "activeDirId": "vhaisx_pcuser1", "status": "active", "userType": "card", "effectiveDate": new Date("2014-01-01 00:00:00")})
db.adminUsers.insert({"id": 1, "lastname": "Joe", "firstname": "G.I.", "activeDirId": "vhaisx_pcuser1", "status": "active", "userType": "user", "effectiveDate": new Date("2014-04-01 00:00:00")})
db.adminUsers.insert({"id": 2, "lastname": "Everhart", "firstname": "Braxton", "activeDirId": "vhaisx_pcuser2", "status": "active", "userType": "card", "effectiveDate": new Date("2014-01-01 00:00:00")})
db.adminUsers.insert({"id": 3, "lastname": "Winchester", "firstname": "Charles", "activeDirId": "vhaisx_pcuser3", "status": "active", "userType": "card", "effectiveDate": new Date("2014-01-01 00:00:00")})
db.adminUsers.insert({"id": 3, "lastname": "Winchester", "firstname": "Charles", "activeDirId": "vhaisx_pcuser3", "status": "inactive", "userType": "card", "effectiveDate": new Date("2014-03-01 00:00:00")})
db.ids.insert([{'name': 'user_id', 'value': 3}, {'name': 'card_id', 'value': 1}])
```

### II. Edit Mongo\_dao\_itest\_test.js ###
 1. Add the database server URL and database name to the `validDbLogin` object.
 2. Type `mocha` at the command line to run the tests.
