//utils.js
var common = {
	//Creates a shallow copy of 2 objects into a new object. If the second object has properties with the same name as the
	// first object, the second objects property value take priority.
	getMerged: function (obj1, obj2) {
		var obj3 = null;
		if (obj1) {
			obj3 = {};
			for (var attrname in obj1) { obj3[attrname] = obj1[attrname]; }
		}
		if (obj2) {
			if (!obj3) {
				obj3 = {};
			}
			for (var attrname in obj2) { obj3[attrname] = obj2[attrname]; }
		}
		return obj3;
	},

	//Shallow copies properties from the second object into the first object. If the first object doesn't exist, a new object is created and returned.
	getMergedInto: function (obj1, obj2) {
		if (obj2) {
			if (!obj1) {
				obj1 = {};
			}
			for (var attrname in obj2) { obj1[attrname] = obj2[attrname]; }
		}
		return obj1;
	}

};

module.exports = common;
