Installing MongoDB
==============================
1. Download MongoDB from https://www.mongodb.org/downloads
2. Extract the tar file
3. Copy the mongo directory to /usr/local/mongodb.

```
$ sudo cp -r ./mongodb-osx-x86_64-2.6.6 /usr/local/mongodb/
```

4. Create symbolic link.

```
$ sudo ln -s /usr/local/mongodb-osx-x86_64-2.6.6 mongodb
```

5. Add mongodb to your PATH
```
export PATH=$PATH:/usr/local/mongodb/bin
```

MongoDB Data Folder
---------------------
By default, MongoDB writes data to the /data/db folder. Create this folder by typing the following:

```
$ sudo mkdir -p /data/db
$ whoami
vbahinwillit
$ sudo chown vbahinwillit /data/db
```

Start MongoDB
---------------------
Start MongoDB in a new terminal.

```
$ mongod
MongoDB starting : pid=34022 port=27017 dbpath=/data/db/ 64-bit host=mkyong.local
//...
waiting for connections on port 27017
```

Start Mongo client in a new terminal.

```
$ mongo
MongoDB shell version: 2.6.6
connecting to: test
> show dbs
local   (empty)
```

Create Pocket Card collection
---------------------

```
$ mongo
$ db.createCollection("pocketcardv1")
$ mongo use pocketcardv1
```

Import Data into MongoDB
---------------------
Once the collection is created, documents can be imported in the collection 2 ways: From the command line or from the mongo shell.

To import data from the command line type the following:

```
$ mongo localhost:27017/pocketcardv1 pocketCard_insertSampleCards.mongo
$ mongo localhost:27017/pocketcardv1 pocketCard_insert_SeedUsers.mongo
```

**NOTE:** Make sure you're in the directory where the import script is located.

To import data from the mongo shell type the following:

```
> load("pocketCard_insertSampleCards.mongo")
> load("pocketCard_insert_SeedUser.mongo")
```

To check if the data was imported type the following from the mongo shell:

```
> use pocketcardv1
> db.cards.find()
> db.adminUsers.find()
```
