PocketCard (MHHPC) - Webservices
==============================
The PocketCard app card data can be retrieved via the following webservices:

1. localhost:1337/pocketcardv1/user/:device_hash/cards
1. localhost:1337/pocketcardv1/user/:device_hash/cards?state=active
2. localhost:1337/pocketcardv1/user/:device_hash/cards/1
2. localhost:1337/pocketcardv1/user/:device_hash/cards/1,2,3
3. localhost:1337/pocketcardv1/user/:device_hash/cards/1/content

Prerequisites
---------------------
* Mongo database must be installed. Instruction for creating the database and tables are located in the data directory.
* You must insert some test data in the 'cards' collection to get results back from the webservice calls.

Installing
---------------------
Run the following commands from the command line:

```
$ npm install
```

This will install all of the libraries and frameworks needed for webservices.
 
Basic Usage
---------------------
Run the following command from the command line to start the server:

```
$ node server.js -c config_local_mongo.js
```

If running on a development workstation, execute the command `npm start` (Mac) or `npm run-script startwin` (Windows).

This will start the server listening on port 1337. To send a webservice request, type one of the following URL's in your favorite browser:

1. localhost:1337/pocketcardv1/user/:device_hash/cards
1. localhost:1337/pocketcardv1/user/:device_hash/cards?state=active
2. localhost:1337/pocketcardv1/user/:device_hash/cards/1
2. localhost:1337/pocketcardv1/user/:device_hash/cards/1,2,3
3. localhost:1337/pocketcardv1/user/:device_hash/cards/1/content

**NOTE**: These webservice request are dependent on the data in the 'card' table in your local database.

Debugging
----------------------
Install node-inspector (https://www.npmjs.org/package/node-inspector) if you haven't already done so.

```
$ npm install -g node-inspector
```

Run the following command from the command line to start the debugger:

```
$ node-inspector service.js
```

**NOTE**: This approach only works for Node.js v12

Known Issues
----------------------
Node.js v10 does not handle debugging clustered apps properly. So, the following steps are neccessary until we move to Node.js v12.

Run the following command from the command line to start the server:

```
$ node server.js -c config_mongo.js &
```

You will see information displayed in the console showing that there is one master process and 8 child processess. We are interested in debugging one of the child processess.

To determine which child process to debug, send a webservice request to our server so we can see which child process is handling requests (see above for how to send a webservice request). Look for the following message displayed in the console:

```
Child: 4, PID: 28035, Debug Port: 5862
```

We see here that our webservice request are being handled by Child process 4 with a process id of 28035 and listening on debugging port 5862. This is all the information we need to start debugging.

Run the following command from the command line to open the debugging port for Child process 4:

```
$ kill -s SIGUSR1 28035
```

**NOTE** You can also open the debugging port by attaching the node debugger to the child process. Type ctrl ^C to exit the debugger.

```
$ node debug -p 28035
connecting...
...
debug> quit
```

You will see the following message displayed in the console:

```
Hit SIGUSR1 - starting debugger agent. debugger listening on port 5862
```

Next, start node inspector by running the following command from the command line:

```
$ node-inspector --debug-port 5862
```

You will see the following message displayed in the console:

```
Visit http://127.0.0.1:8080/debug?port=5862 to start debugging
```

Type this URL in your browser, set your break points, send a webservice request, and start debugging!

Npm Script Names
----------------------

# preflight
For Production Use: Minimum - force set secure permissions.  Optionally execute script to test environment.

# test
Placeholder: Run functional/unit tests

# build
Placeholder: Create a versioned tar.gz file of the application for production install.

# process:add
Add application process

# process:remove
Remove application process

# process:restart
Start/restart application

# process:stop
Stop application

# deploy:*
Complete steps for application installation in selected environment

For example `npm run-script deploy:dev`

# upgrade:*
Complete steps for application upgrade in selected environment (bpr-dev)

# remove:*
Complete steps for application UNinstallation in development environment (bpr-dev)

# status      
Provide information on operating status
     
# nginx:*      
System Administration Tasks for Nginx
 